//*******************************************************************************//
//										
//     IN QUESTO FILE SONO RACCOLTE TUTTE MACRO PER I PIC18Fxx2 E PIC18Fxx8
//     V 1.3 					     (ultimo agg. 04/02/04)
//										
//    MODIFICATO LA MACRO PER I MICROSECONDI!!!	
//     MODIFICARE LA MACRO PER I MILLISECONDI!!!
//*******************************************************************************//


//-------------------------------------------------------------------------------//
//	MACRO CHE COPIA IL VALORE DI UN BIT DA UN REGISTO AD UN'ALTRO
//       Timing:  4 clks			
//       PM: 4            			
//-------------------------------------------------------------------------------//
//#define Bit_To_Bit(argom1, argbit1, argom2, argbit2) _asm BTFSS	argom1, argbit1	BCF	argom2, argbit2	BTFSC	argom1, argbit1 BSF	argom2, argbit2	_endasm

//-------------------------------------------------------------------------------//
//	LITTERAL IN F				
//       Timing:  2 clks	
//       PM: 2            		
//-------------------------------------------------------------------------------//
//#define MOVLF(lettera, registro) _asm MOVLW	lettera	MOVWF	registro _endasm


//*******************************************************************************//
//					
//	MACRO CHE SETTANO IL PUNTATORE PER LA LETTURA DELLE TABELLE
//					
//		Setta il puntatore in cima alla tabella
//	USO:	TabSetting	<LabelTable>
//								
//		Aggiunge W al puntatore di base (a 21 bit) della tabella
//	USO:	AddTab						
//							
//		Aggiunge W * Num al puntatore di base (a 21 bit) della tabella
//	USO:	AddMulTab	< Num >			
//					
//		Setta il puntatore all'elemento <index> della tabella
//	USO:	TabSetpoint	<LabelTable>, <Index>
//				
//*******************************************************************************//
//#define TabSetting(TablePointer) (TBLPTR = TablePointer)

//#define AddTab _asm ADDWF	TBLPTRL, F MOVLW 0 ADDWFC	TBLPTRH, F	ADDWFC	TBLPTRU, F _endasm

//#define AddMulTab(Mult) _asm MULLW	Mult MOVF	PRODL, W ADDWF	TBLPTRL, F	MOVF	PRODH, W ADDWFC	TBLPTRH, F MOVLW 0	ADDWFC	TBLPTRU, F _endasm
		
//#define TabSetpoint(TablePointer, Index) _asm MOVLW	upper	TablePointer + Index MOVWF	TBLPTRU MOVLW	high	TablePointer + Index MOVWF	TBLPTRH MOVLW	low	TablePointer + Index _endasm

//*******************************************************************************//
//										
//	MACRO CHE PRODUCONO UN'ATTESA DI UN NUMERO PRESTABILITO DI us, ms o s
//										
//	Affinch la macro funzioni bene deve essere definita la frequenza	
//	di lavoro del perocessore nel main program tramite l'istruzione:
//										
//	#define FREQUENCY <Frequenza>	// Frequenza del procesore in KHz 
//					(va considerato anche l'eventuale PLL)	
//	Se nessuna frequenza e' definita la macro di default utilizza 16 MHz
//										
//	USO:	DelayMicroSec	< N >						
//		Provoca un attesa di N microsecondi (fino a 25599 us a 16 MHz)	
//	Precisione tipica 1% con delay > 10 us - 0.25us con delay < 10 us
//										
//	USO:	DelayMilliSec	< N >						
//		Provoca un attesa di N millisecondi (fino a 25599 ms a 16 MHz)	
//	Precisione tipica 0.1% 						
//										
//	CON 	N > 0								
//*******************************************************************************//


//#define DelayMicroSec(Time) {_asm ifdef	FREQUENCY Microsecondi = ((Time * FREQUENCY)/16000) endif if Microsecondi > 100 PUSH MOVLW	Microsecondi / 100 MOVWF	TOSL	MOVLW 100 CLRWDT DECFSZ	WREG DB	0xFD,0xD7 DECFSZ	TOSL DB	0xFA,0xD7 MOVLW	Microsecondi % 100 BZ	$+8 NOP DECFSZ	WREG DB	0xFD,0xD7 POP endif if Microsecondi < 101 MOVLW	Microsecondi CLRWDT DECFSZ	WREG DB	0xFD,0xD7 endif _endasm}

//#define DelayMilliSec(Time2) {_asm ifdef	FREQUENCY Millisecondi = ((Time2 * FREQUENCY)/16000) endif if Millisecondi > 100 PUSH MOVLW	Millisecondi / 100 MOVWF TOSH MOVLW	100 MOVWF TOSL MOVLW 250 CLRWDT	NOP NOP NOP NOP NOP NOP NOP NOP NOP NOP NOP NOP DECFSZ	WREG DB	0xF1,0xD7 DECFSZ TOSL DB 0xEE,0xD7 DECFSZ TOSH DB 0xEA,0xD7 MOVLW Millisecondi % 100 MOVWF	TOSL MOVLW 250 CLRWDT NOP NOP NOP NOP NOP NOP NOP NOP NOP NOP NOP NOP DECFSZ WREG DB 0xF1,0xD7 DECFSZ TOSL DB 0xEE,0xD7 POP endif if Millisecondi < 101 PUSH MOVLW	Millisecondi MOVWF	TOSL MOVLW	25 NOP NOP NOP NOP NOP NOP NOP NOP NOP NOP NOP NOP NOP DECFSZ WREG DB 0xF1,0xD7	DECFSZ	TOSL DB	0xEE,0xD7 POP endif _endasm}

#ifndef __18FMACROH
#define __18FMACROH

#include <delays.h>

//#define MILLISECONDS(Time)	(Delay10KTCYx(FREQUENCY/40000*Time))		// 1ms = Delay10KTCYx(1);  255ms max delay
//#define MICROSECONDS(Time2)	(Delay10TCYx(FREQUENCY/40000*Time2))   	// 1us = Delay10TCYx(1); 255 microseconds max delay

// Assumes that FREQUENCY = 40000:
#define MILLISECONDS(Time)	(Delay10KTCYx(Time))	// 1ms = Delay10KTCYx(1);  255ms max delay
#define MICROSECONDS(Time2)	(Delay10TCYx(Time2))   	// 1us = Delay10TCYx(1); 255 microseconds max delay


#endif
